#include "nSystem.h"
#include "fifoqueues.h"

int ticket_isla=0, ticket_continente=0;
int visor_isla=0, visor_continente=0;
nMonitor mon;
void navegarAIsla();
void navegarAContinente();

void cruzarAIsla() {
    nEnter(mon);
    int mi_ticket = ++ticket_continente;
    nNotifyAll(mon);
    while(mi_ticket > visor_continente)
        nWait(mon);
    nPrintf("cruzo a isla %i\n", mi_ticket);
    nExit(mon);
}
void cruzarAContinente() {
    nEnter(mon);
    int mi_ticket = ++ticket_isla;
    nNotifyAll(mon);
    while(mi_ticket > visor_isla)
        nWait(mon);
    nPrintf("cruzo a continente %i\n", mi_ticket);
    nExit(mon);
}

int barcaza(){
    int enContinente = TRUE;
    int atiendo_continente, atiendo_isla;
    for(;;){
        nEnter(mon);
        while(ticket_isla <= visor_isla && ticket_continente <= visor_continente)
            nWait(mon);
        atiendo_continente = atiendo_isla = FALSE;
        if(enContinente && ticket_continente > visor_continente)
            atiendo_continente = TRUE;
        else if(!enContinente && ticket_isla > visor_isla)
            atiendo_isla = TRUE;
        nExit(mon);
        if(enContinente){
            navegarAIsla();
            nPrintf("continente ==> isla\n");
        } else {
            navegarAContinente();
            nPrintf("continente <== isla\n");
        }
        enContinente = !enContinente;
        if(atiendo_continente){
            nEnter(mon);
            visor_continente++;
            nNotifyAll(mon);
            nExit(mon);
        } else if(atiendo_isla){
            nEnter(mon);
            visor_isla++;
            nNotifyAll(mon);
            nExit(mon);
        }
    }
}
int isleno();
int turista();
int nMain(){
    mon = nMakeMonitor();
    nEmitTask(isleno);
    nEmitTask(isleno);
    nEmitTask(turista);
    nEmitTask(turista);
    nEmitTask(barcaza);
    nSleep(3000);
}
void dormir(){
    nSleep(700);
}
void trabajar(){
    nSleep(400);
}
void turistear(){
    nSleep(600);
}
void navegarAIsla(){
    nSleep(200);
}
void navegarAContinente(){
    nSleep(200);
}
int isleno() {
    for(;;) {
        cruzarAContinente();
        trabajar();
        cruzarAIsla();
        dormir();
    }
}
int turista() {
    for(;;) {
        cruzarAIsla();
        turistear();
        cruzarAContinente();
        dormir();
    }
}
