typedef struct Orden {
	Pizza *pizza;
	int cocida;
} Orden;

nMonitor ctrl;
nTask pizzeriaTask;
FifoQueue *pendientes;

void iniciarPizzeria() {
	ctrl = nMakeMonitor();
	pizzeriaTask = nEmitTask(pizzeriaProc);
	hambrientos = MakeFifoQueue();
	hackers = MakeFifoQueue();
}

Orden* ordenarPizza() {
	Orden *ord = (Orden*) nMalloc(sizeof(Orden));
	ord->pizza = obtenerPizzaCruda();
	ord->cocida = FALSE;
	nEnter(ctrl);
	PutObj(pendientes, ord);
	nNotifyAll(ctrl);
	nExit(ctrl);
	return ord;
}

Pizza* esperarPizza(Orden *po) {
	nEnter(ctrl);
	while (!po->cocida)
		nWait(ctrl);
	nExit(ctrl);
	Pizza* pizza = po->pizza;
	nFree(po);
	return pizza;
}

Pizza* comprarPizza() {
	return esperarPizza(ordenarPizza());
}

int pizzeriaProc() {
	int cont, i, P = 4;
	Pizza *pizza_vec[P];
	Orden *orden_vec[P];
	for (;;) {
		cont = 0;
		nEnter(ctrl);
		while (EmptyFifoQueue(pendientes))
			nWait(ctrl);
		while (!EmptyFifoQueue(pendientes) && cont < P) {
			orden_vec[cont] = (Orden*) GetObj(pendientes);
			pizza_vec[cont] = orden_vec[cont]->pizza;
			cont++;
		}
		nExit(ctrl);
		hornear(horno, pizza_vec, cont);
		nEnter(ctrl);
		for (i = 0; i < cont; i++)
			orden_vec[i]->cocida = TRUE;
		nNotifyAll(ctrl);
		nExit(ctrl);
	}
	return 0;
}
